/*jslint nomen:true,regexp:true*/
/*globals define*/

define([
    'testsuite/qunit',
    'jquery',
    'ep',
    'de_epages/presentation/tray/main-view',

    '$ready!'
], function (QUnit, $, ep, Mainview) {
    'use strict';

    var fixture = $('#qunit-fixture'),
        options = {
            tabs: {
                'products': {
                    id: 'view1',
                    name: 'products',
                    additionalContent: '<input type="checkbox" name="checkboxAdditionalContent" />',
                    action: 'JSONInsertFromProducts'
                }
            },
            afterRender: function () {}
        },
        mainview,
        data = {
            "tableHead": [{
                "isSortable": 0,
                "name": "",
                "id": "ObjectID",
                "isSelectable": 1
            }, {
                "isSortable": 1,
                "name": "Product number",
                "id": "Alias",
                "isSelectable": 0
            }, {
                "isSortable": 1,
                "name": "",
                "id": "NameOrAlias",
                "isLinkable": 1,
                "isSelectable": 0
            }, {
                "isSortable": 0,
                "name": "",
                "id": "VariationAttr",
                "isSelectable": 0
            }, {
                "isSortable": 1,
                "name": "List price",
                "id": "ListPrice",
                "isSelectable": 0
            }],
            "totalNumber": "22",
            "orderBy": "NameOrAlias",
            "lastPage": 2,
            "orderDesc": 0,
            "tableContent": {
                "1": [{
                    "Alias": "be_40401",
                    "Parents": [],
                    "ObjectID": 17144,
                    "VariationAttr": null,
                    "NameOrAlias": "Berghaus Paclite Jacket - Men",
                    "hasSubTable": 1,
                    "ListPrice": "199.95 €"
                }, {
                    "Alias": "be_40402",
                    "Parents": [],
                    "ObjectID": 17156,
                    "VariationAttr": null,
                    "NameOrAlias": "Berghaus Paclite Jacket - Women",
                    "hasSubTable": 1,
                    "ListPrice": "199.95 €"
                }, {
                    "Alias": "vs_3202112018",
                    "Parents": [],
                    "ObjectID": 17215,
                    "VariationAttr": null,
                    "NameOrAlias": "Black Bear Gemini",
                    "ListPrice": "29.95 €"
                }, {
                    "Alias": "cg_0101004270",
                    "Parents": [],
                    "ObjectID": 17137,
                    "VariationAttr": null,
                    "NameOrAlias": "Camping AZ CV270 valve gas canister",
                    "ListPrice": "3.95 €"
                }, {
                    "Alias": "cg_0101104470",
                    "Parents": [],
                    "ObjectID": 17138,
                    "VariationAttr": null,
                    "NameOrAlias": "Camping AZ CV470 valve Gas canister",
                    "ListPrice": "7.95 €"
                }, {
                    "Alias": "de_3201212002",
                    "Parents": [],
                    "ObjectID": 17212,
                    "VariationAttr": null,
                    "NameOrAlias": "Deuter Hydro 2.0",
                    "ListPrice": "74.95 €"
                }, {
                    "Alias": "de_3203104010",
                    "Parents": [],
                    "ObjectID": 17213,
                    "VariationAttr": null,
                    "NameOrAlias": "Deuter Kangaroo",
                    "ListPrice": "99.95 €"
                }, {
                    "Alias": "de_3206199010",
                    "Parents": [],
                    "ObjectID": 17216,
                    "VariationAttr": null,
                    "NameOrAlias": "Deuter Teddy Bear",
                    "ListPrice": "26.95 €"
                }, {
                    "Alias": "er_7142303001",
                    "Parents": [],
                    "ObjectID": 17139,
                    "VariationAttr": null,
                    "NameOrAlias": "Edelrid Black Bear Rope",
                    "ListPrice": "1.45 €"
                }],
                "2": [{
                    "Alias": "be_40401",
                    "Parents": [],
                    "ObjectID": 17144,
                    "VariationAttr": null,
                    "NameOrAlias": "Berghaus Paclite Jacket - Men",
                    "hasSubTable": 1,
                    "ListPrice": "199.95 €"
                }, {
                    "Alias": "be_40402",
                    "Parents": [],
                    "ObjectID": 17156,
                    "VariationAttr": null,
                    "NameOrAlias": "Berghaus Paclite Jacket - Women",
                    "hasSubTable": 1,
                    "ListPrice": "199.95 €"
                }]
            }
        },
        subData = {
            "tableHead": [{
                "name": "",
                "id": "ObjectID",
                "isSelectable": 1
            }, {
                "isSortable": 1,
                "name": "Artikelnummer",
                "id": "Alias"
            }, {
                "isSortable": 1,
                "isLinkable": 1,
                "name": "Name",
                "id": "NameOrAlias"
            }, {
                "name": "",
                "id": "VariationAttr"
            }, {
                "isSortable": 1,
                "name": "Listenpreis",
                "id": "ListPrice"
            }],
            "totalNumber": "10",
            "orderBy": "NameOrAlias",
            "lastPage": 1,
            "path": [{
                "ObjectID": "17038",
                "NameOrAlias": "Products"
            }, {
                "ObjectID": "17177",
                "NameOrAlias": "Berghaus Paclite Jacket - Women"
            }],
            "orderDesc": 0,
            "tableContent": {
                "1": [{
                    "Alias": "be_4040203036",
                    "ObjectID": 17179,
                    "VariationAttr": "(Extrem Rot, S)",
                    "NameOrAlias": "Berghaus Paclite Jacket - Women",
                    "ListPrice": "199,95 €"
                }, {
                    "Alias": "be_4040203038",
                    "ObjectID": 17180,
                    "VariationAttr": "(Extrem Rot, M)",
                    "NameOrAlias": "Berghaus Paclite Jacket - Women",
                    "ListPrice": "199,95 €"
                }, {
                    "Alias": "be_4040203040",
                    "ObjectID": 17181,
                    "VariationAttr": "(Extrem Rot, L)",
                    "NameOrAlias": "Berghaus Paclite Jacket - Women",
                    "ListPrice": "199,95 €"
                }, {
                    "Alias": "be_4040203042",
                    "ObjectID": 17182,
                    "VariationAttr": "(Extrem Rot, XL)",
                    "NameOrAlias": "Berghaus Paclite Jacket - Women",
                    "ListPrice": "199,95 €"
                }, {
                    "Alias": "be_4040203044",
                    "ObjectID": 17183,
                    "VariationAttr": "(Extrem Rot, XXL)",
                    "NameOrAlias": "Berghaus Paclite Jacket - Women",
                    "ListPrice": "199,95 €"
                }, {
                    "Alias": "be_4040201036",
                    "ObjectID": 17184,
                    "VariationAttr": "(Schwarz, S)",
                    "NameOrAlias": "Berghaus Paclite Jacket - Women",
                    "ListPrice": "199,95 €"
                }, {
                    "Alias": "be_4040201038",
                    "ObjectID": 17185,
                    "VariationAttr": "(Schwarz, M)",
                    "NameOrAlias": "Berghaus Paclite Jacket - Women",
                    "ListPrice": "199,95 €"
                }, {
                    "Alias": "be_4040201040",
                    "ObjectID": 17186,
                    "VariationAttr": "(Schwarz, L)",
                    "NameOrAlias": "Berghaus Paclite Jacket - Women",
                    "ListPrice": "199,95 €"
                }, {
                    "Alias": "be_4040201042",
                    "ObjectID": 17187,
                    "VariationAttr": "(Schwarz, XL)",
                    "NameOrAlias": "Berghaus Paclite Jacket - Women",
                    "ListPrice": "199,95 €"
                }, {
                    "Alias": "be_4040201044",
                    "ObjectID": 17188,
                    "VariationAttr": "(Schwarz, XXL)",
                    "NameOrAlias": "Berghaus Paclite Jacket - Women",
                    "ListPrice": "199,95 €"
                }]
            }
        },
        _ajax = ep.ajax;

    ep.ajax = function (o) {
        if (o.data.ObjectID) {
            return {
                done: function (f) {
                    if (o.data.ParentObjectID) {
                        f(subData);
                    } else {
                        f(data);
                    }
                }
            };
        }

        return _ajax(o);
    };

    QUnit.module("de_epages/presentation/main-view", {
        setup: function () {
            mainview = new Mainview(options);
            mainview.render().$el.appendTo(fixture);
        },
        teardown: function () {
            fixture.empty();
        }
    });

    QUnit.test('Check main-view\'s public methods', function () {
        $.each([
            'initialize',
            'render',
            'updateSelectedElements',
            'showSearchResults',
            'createContent'
        ], function () {
            QUnit.ok(
                $.isFunction(mainview[this]),
                'Check if ' + this + ' is a method of the tray'
            );
        });
    });

    QUnit.test('Check DOM structure', function () {
        var searchInput, additionalContent;

        QUnit.ok(
            mainview.$('.ui-tabs').length > 0,
            'Check if tabs widget was created successfully'
        );

        QUnit.strictEqual(
            fixture.find('.ep-tray-tab').length,
            2,
            'Check if we have our two tabs created (products and selected items)'
        );

        /* TEST INITIAL VISIBILITY OF THE TABS */
        QUnit.equal(
            fixture.find('#ep-tray-' + mainview.cid + '-products').css('display'),
            'block',
            'Check if the products tab initially is visible'
        );

        QUnit.equal(
            fixture.find('#ep-tray-' + mainview.cid + '-selected').css('display'),
            'none',
            'Check if the selected tab initially is invisible'
        );

        /* TEST DISPLAYING A SUB-PRODUCT */
        mainview.views.view1.instance.on('changecontent', function () {
            QUnit.ok(
                fixture.find('label[for=17181]').length >= 1,
                'Should show some content for the ID 17181 after displaying a sub-product'
            );
        });

        fixture.find('a[data-id=17156]').trigger('click');


        /* TEST THE SEARCH EVENT */
        mainview.views.view1.instance.trigger('search', 'TheSearchString');

        QUnit.equal(
            fixture.find('input.ep-tray-searchfield').val(),
            'TheSearchString',
            'Check if "TheSearchString" is the new content of the search input'
        );

        QUnit.equal(
            mainview.views.search.instance.searchString,
            'TheSearchString',
            'Check if the search view is filtered by "TheSearchString"'
        );

        QUnit.equal(
            $(mainview.views.search.instance.el).parent().css('display'),
            'block',
            'Check if the products view is visible'
        );

        /* SELECT AN ELEMENT */
        fixture.find('#17156').trigger('click');
        /.+(\d+)/.exec(fixture.find('ul.ui-tabs-nav li').eq(1).text());
        QUnit.equal(
            RegExp.$1,
            '1',
            'Check if the selected elements tab shows how many elements have been selected'
        );

        /* TEST ADDITIONAL CONTENT */
        additionalContent = fixture.find('#ep-tray-' + mainview.cid + '-products span.additional-content');
        QUnit.strictEqual(
            additionalContent.find('input[name=checkboxAdditionalContent]').length,
            1,
            'Check if the additional content is displayed'
        );

        additionalContent.find('input[name=checkboxAdditionalContent]').trigger('click');
        QUnit.deepEqual(mainview.getSelectedElements().products.options, {
            checkboxAdditionalContent: true
        }, 'Check if the correct additional content is returned');

        fixture.find('a[data-id="17144"]').trigger('click');
        QUnit.strictEqual(
            additionalContent.find('input[name=checkboxAdditionalContent]').prop('checked'),
            true,
            'Check if the additional content is also checked in sub view'
        );

        /* TEST THE CLICK ON A TAB */
        fixture.find('ul li.ep-tray-tab-selected a').trigger('click');

        QUnit.equal(
            fixture.find('#ep-tray-' + mainview.cid + '-products').css('display'),
            'none',
            'Check if the products tab is invisible after changing to selected tab'
        );

        QUnit.equal(
            fixture.find('#ep-tray-' + mainview.cid + '-selected').css('display'),
            'block',
            'Check if the selected tab is visible after changing to selected tab'
        );
    });
});